<?php

namespace App\Helper;

use Illuminate\Support\Facades\Log;

class DataMapper {

    protected $tabelaPreco;

    public function __construct($tabelaPreco) {
        $this->tabelaPreco = $tabelaPreco;
    }

    public function mapProducts($expectedOperations)
    {
        $mappedProducts = [];

        $mappedProducts[0] = [
            'id'        => $this->tabelaPreco->getTaxaOperacao($expectedOperations)['id'],
            'qty'       => $expectedOperations,
            'discount'  => 0,
        ];

        $mappedProducts[1] = [
            'id'        => 2,
            'qty'       => 0,
            'discount'  => 0,
        ];

        Log::info('Produtos mapeados: ', $mappedProducts);

        return $mappedProducts;
    }

    public function mapTags($label_ids)
    {
        $mappedTags = [
            247 => 2,
            248 => 3,
            249 => 4
        ];

        $mappedResult = array_values(array_map(function ($id) use ($mappedTags) {
            return $mappedTags[$id] ?? null;
        }, array_filter($label_ids, function ($id) use ($mappedTags) {
            return isset($mappedTags[$id]);
        })));

        if(!in_array(9, $mappedResult, true)) {
            $mappedResult[] = 9;
        }

        return $mappedResult;
    }

    function mapPipeDriveTypeToEvotalksAction($pipedriveType)
    {
        $typeMapping = [
            'call'      => 1,       // Ligar
            'meeting'   => 3,       // Reunião
            'chat'      => 2,       // Chat
            'whatsapp'  => 2,       // Chat (WhatsApp)
            'task'      => 0,       // Sem ação
        ];

        return $typeMapping[$pipedriveType] ?? 0;
    }
}