<?php

namespace App\Http\Controllers;

use App\Services\PipeDriveService;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Http;
use Illuminate\Support\Facades\Log;

class PipeDriveController extends Controller
{
    protected $pipedriveService;

    public function __construct(PipedriveService $pipedriveService)
    {
        $this->pipedriveService = $pipedriveService;
    }

    public function getDealV2($id)
    {
        return response()->json($this->pipedriveService->getDealV2($id));
    }

    public function getDeal($id)
    {
        return response()->json($this->pipedriveService->getDeal($id));
    }

    public function fetchNotes($dealId)
    {
        $notes = $this->pipedriveService->fetchNotes($dealId);
        return response()->json(['notes' => $notes]);
    }

    public function fetchDealFlowActivities($dealId)
    {
        $activities = $this->pipedriveService->fetchDealFlowActivities($dealId);
        return response()->json(['activities' => $activities]);
    }
}
