<?php

namespace App\Helper;

use Illuminate\Http\Request;

class PipeDriveToEvoTalksMapper {
    protected $ArrayHelper;
    protected $DataMapper;

    public function __construct(ArrayHelper $ArrayHelper, DataMapper $DataMapper) {
        $this->ArrayHelper = $ArrayHelper;
        $this->DataMapper = $DataMapper;
    }
    public function mapPipeDriveToEvoTalks($pipeDriveData, $dealV2, $fkPipeline, $fkStage, $contact)
    {

        $value = $pipeDriveData['value'] ?? 0;
        $productsCount = (!isset($pipeDriveData['products_count']) || $pipeDriveData['products_count'] == 0) ? 1 : $pipeDriveData['products_count'];
        $FeeValue = $value == 0 ? 0 : number_format($value / $productsCount, 2, '.', '');

        return new Request([
            'fkPipeline'        => $fkPipeline,
            'fkStage'           => $fkStage,
            'responsableid'     => 507,
            'title'             => $pipeDriveData['title'] ?? '',
            'clientid'          => $this->ArrayHelper->safeGet($pipeDriveData, 'person_id.name'),
            'mainphone'         => $this->ArrayHelper->safeGet($pipeDriveData, 'person_id.phone.0.value'),
            'mainmail'          => $pipeDriveData['person_id']['email'][0]['value'],
            'description'       => preg_replace('/<br\s*\/?>/i', "\n", $this->ArrayHelper->safeGet($dealV2, 'custom_fields.8ebbdb58a2067decc8b6d2d0849bb67c4bfc13d1')),
            'expectedclosedate' => $pipeDriveData['expected_close_date'] ?? null,
            'formattedlocation' => $this->ArrayHelper->safeGet($pipeDriveData, 'org_id.name'),
            'postalcode'        => $this->ArrayHelper->safeGet($pipeDriveData, 'org_id.address_postal_code', ''),
            'address1'          => $this->ArrayHelper->safeGet($pipeDriveData, 'org_id.address', ''),
            'address2'          => '',
            'city'              => $this->ArrayHelper->safeGet($pipeDriveData, 'org_id.address_city', ''),
            'state'             => $this->ArrayHelper->safeGet($pipeDriveData, 'org_id.address_state', ''),
            'country'           => $this->ArrayHelper->safeGet($pipeDriveData, 'org_id.address_country', ''),
            'countrycode'       => $this->ArrayHelper->safeGet($pipeDriveData, 'org_id.address_country_code', ''),
            'lat'               => $this->ArrayHelper->safeGet($pipeDriveData, 'org_id.address_lat', 0),
            'lon'               => $this->ArrayHelper->safeGet($pipeDriveData, 'org_id.address_long', 0),
            'probability'       => $pipeDriveData['probability'] ?? 0,
            'value'             => $FeeValue,
            'recurrentvalue'    => $pipeDriveData['recurrentvalue'] ?? 0,
            'origin'            => 0,
            'formsdata'         => (object) [],
            'tags'              => $dealV2['label_ids'] == [] ? [] : $this->DataMapper->mapTags($dealV2['label_ids']),
            'files'             => [],
            'contacts'          => [$contact],
            'followers'         => [],
            'products'          => $value == 0 || $pipeDriveData['products_count'] == 0 ? [] : $this->DataMapper->mapProducts($pipeDriveData['products_count'] ?? []),
        ]);
    }
}