<?php

namespace App\Helper;

use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Http;

class SendPost
{
    private $baseUrl;
    private $apiKey;
    private $queueId;

    public function __construct()
    {
        $this->apiKey = env('EVOTALKS_API_KEY');
        $this->baseUrl = env('EVOTALKS_BASE_URL');
        $this->queueId = env('EVOTALKS_API_QUEUEID');
    }

    private function apiHeaders()
    {
        return [
            'Accept' => 'application/json',
            'Content-Type' => 'application/json',
        ];
    }

    public function sendPostRequest($endpoint, $data)
    {
        $response = Http::withHeaders($this->apiHeaders())
            ->post("{$this->baseUrl}{$endpoint}", array_merge($data, [
                'queueId' => $this->queueId,
                'apiKey' => $this->apiKey,
            ]));

        if ($response->successful()) {
            return $response->json();
        }

        Log::error('Erro na requisição ao EvoTalks', [
            'endpoint' => $endpoint,
            'status' => $response->status(),
            'body' => $response->body(),
        ]);

        return null;
    }
}
