<?php

namespace App\Http\Controllers;

use App\Helper\SlackNotifier;
use App\Services\CRMService;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Http;

class CRMController extends Controller
{
    protected $crmService;

    public function __construct(CRMService $crmService)
    {
        $this->crmService = $crmService;
    }

    public function sendWaTemplate(Request $request)
    {
        return $this->crmService->sendWaTemplateService($request->input('number'), $request->input('stageId'), $request->input('variavel1'));
    }

    public function newClientTag(Request $request)
    {
        return $this->crmService->newClientTagService($request->input('id'));
    }

    public function openNewChat(Request $request)
    {
        return $this->crmService->openNewChatService($request->input('number'));
    }
}
