<?php

namespace App\Http\Controllers;

use App\Services\PipeDriveService;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Http;
use Illuminate\Support\Facades\Log;

class PipeDriveController extends Controller
{
    protected $pipedriveService;

    public function __construct(PipedriveService $pipedriveService)
    {
        $this->pipedriveService = $pipedriveService;
    }

    public function getDealV2($id)
    {
        return $this->pipedriveService->getDealV2Service($id);
    }

    public function getDeal($id)
    {
        return $this->pipedriveService->getDealService($id);
    }

    public function fetchNotes($dealId)
    {
        $notes = $this->pipedriveService->fetchNotesService($dealId);
        return $notes;
    }

    public function fetchDealFlowActivities($dealId)
    {
        $activities = $this->pipedriveService->fetchDealFlowActivities($dealId);
        Log::info("Atividades: ", [$activities]);
        return $activities;
    }
}
