<?php

use Firebase\JWT\JWT;
use Firebase\JWT\Key;

function protect($request, $response, $next) {
    $headers = getallheaders();
    $secretKey = $_ENV['JWT_KEY'];

    if (isset($headers['Authorization']) && preg_match('/Bearer\s(\S+)/', $headers['Authorization'], $matches)) {
        $token = $matches[1];

        try {
            $access = JWT::decode($token, new Key($secretKey, 'HS256'));
            $request['user'] = $access;
            return $next($request, $response);
        } catch (Exception $th) {
            http_response_code(401);
            echo json_encode(['message' => 'Token inválido. Acesso não autorizado']);
            exit;
        }
    }

    http_response_code(401);
    echo json_encode(['message' => 'Nenhum token fornecido. Acesso negado']);
}