<?php

namespace App\Services;

use App\Services\ControleService;
use Illuminate\Support\Facades\Log;

class GetLocCount {
    protected $controleService;

    public function __construct(ControleService $controleService) {
        $this->controleService = $controleService;
    }

    public function locCount($codOpportunitiesList) {
        $results = [];
        $counter = 0;
        $limitPerMinute = 50;
        $startTime = microtime(true);

        foreach ($codOpportunitiesList as $codOpportunitty) {
            $imobia_cod = $codOpportunitty['imobia_cod'] ?? null;
            $id = $codOpportunitty['id'] ?? null;

            if ($imobia_cod) {
                $result = $this->controleService->countLocacaoService($imobia_cod);
                $qty = $result['locacoes_ativas'] ?? 0;
                $expected = $result['expectativa_operacoes'] ?? 0;

                $results[] = [
                    'imobia_cod'    => $imobia_cod,
                    'qty'           => $qty,
                    'id'            => $id,
                    'expected'      => $expected
                ];

                $counter ++;

                if ($counter % $limitPerMinute == 0) {
                    $elapsedTime = microtime(true) - $startTime;

                    if ($elapsedTime < 60 ){
                        sleep(60 - $elapsedTime);
                    }

                    $startTime = microtime(true);
                }
            }
        }

        return $results;
    }
}