<?php

namespace App\Services;

use App\Helper\SendPost;
use App\Services\CRMService;
use Illuminate\Support\Facades\Log;

class GetOpportunitiesStage
{
    protected $sendPost;
    protected $crmService;

    public function __construct(SendPost $sendPost, CRMService $crmService)
    {
        $this->sendPost = $sendPost;
        $this->crmService = $crmService;
    }

    public function getOpportunitiesStage($stageId, $title, $mainphone)
    {
        Log::info('getOpp', [$stageId, $title, $mainphone]);
        if (isset($stageId) && isset($title) && isset($mainphone)) {
            $return = $this->crmService->sendWaTemplateService($mainphone, $stageId, $title);
            return response()->json([$return]);
        }
    }
}
