<?php

namespace App\Services;

use App\Helper\DataMapper;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Http;

class UpdateTagToControle {
    protected $dataMapper;

    public function __construct (DataMapper $dataMapper) {
        $this->dataMapper = $dataMapper;
    }

    public function updateTagControle(Request $request) {
        try {
            Log::info('Recebendo tag do CRM: ', [$request->all()]);

            $label_ids = $request->input('label_ids', []);
            $mappedTags = $this->dataMapper->mapTags($label_ids);
            $payload = [
                'tags'=> $mappedTags,
                'opportunity_id' => $request->input('opportunity_id')
            ];

            $response = Http::post('https://imobiahost.com.br/pipe-talks/public/', $payload);

            Log::info('Responsta do endpoint externo: ', ['status' => $response->status(), 'body' => $response->body()]);

            return response()->json(['success' => true, 'message' => 'Tags atualizadas no controle'], 200);
        } catch (\Exception $e) {
            Log::error('Erro ao atualizar tag no controle', ['error' => $e->getMessage()]);
            return response()->json(['Erro ao atualizar tag no controle'], 500);
        }
    }
};