<?php

use App\Http\Controllers\Api4Controller;
use App\Http\Controllers\EvoTalksController;
use App\Http\Controllers\PipeDriveController;
use App\Http\Controllers\SyncController;
use App\Http\Controllers\ControleController;
use App\Http\Controllers\UpdateTag;
use App\Http\Controllers\CRMController;
use App\Services\ServiceMigrationPipeForEvo;
use Illuminate\Support\Facades\Route;

Route::prefix('pipeforevo')->name('pipeforevo.')->middleware('jwt.auth')->group(function () {
    Route::get('/migrate-opportunities', [ServiceMigrationPipeForEvo::class, 'migrateOpportunities']);
});

Route::prefix('evotalks')->name('evotalks.')->middleware('jwt.auth')->group(function () {
    Route::post('/create-opportunity',              [EvoTalksController::class, 'createOpportunity'])->name('create');
    Route::post('/remove-opportunity',              [EvoTalksController::class, 'removeOpportunity'])->name('remove');
    Route::post('/lose-opportunity',                [EvoTalksController::class, 'loseOpportunity'])->name('lose');
    Route::post('/win-opportunity',                 [EvoTalksController::class, 'winOpportunity'])->name('win');
    Route::post('/transfer-opportunity',            [EvoTalksController::class, 'transferOpportunity'])->name('transfer');
    Route::post('/change-opportunity-stage',        [EvoTalksController::class, 'changeOpportunityStage'])->name('change-stage');
    Route::post('/insert-opportunity-note',         [EvoTalksController::class, 'insertOpportunityNote'])->name('insert-note');
    Route::post('/add-notes-to-opportunity',        [EvoTalksController::class, 'addNotesToOpportunity'])->name('add-notes');
    Route::post('/getOpportunity',                  [EvoTalksController::class, 'getOpportunity'])->name('get');
    Route::post('/getCodOpportunities',             [EvoTalksController::class, 'getCodOpportunitiesFunnel'])->name('get-pipe');
    Route::post('/create-task',                     [EvoTalksController::class, 'createTask'])->name('create-task');
    Route::post('/markAsDone',                      [EvoTalksController::class, 'markAsDone'])->name('markAsDone');
    Route::post('/getContact',                      [EvotalksController::class, 'getContact'])->name('getContact');
    Route::post('/updateOpportunittyProduct',       [EvotalksController::class, 'updateOpportunittyProduct'])->name('updateOppProd');
});

Route::prefix('evotalk')->name('evotalk.')->group(function () {
    Route::post('/getOpportunitiesStage',           [EvoTalksController::class, 'getOpportunitiesStage'])->name('get-OpportunitiesStage');
});

Route::prefix('pipedrive')->name('pipedrive.')->middleware('jwt.auth')->group(function () {
    Route::get('/deals',                            [PipeDriveController::class, 'getDeals'])->name('deals');
    Route::get('/deal/{id}',                        [PipeDriveController::class, 'getDeal'])->name('dealCod');
    Route::get('/dealV2/{id}',                      [PipeDriveController::class, 'getDealV2'])->name('deal');
    Route::put('/deal/{id}',                        [PipeDriveController::class, 'updateDeal'])->name('update');
});

Route::prefix('sync')->name('sync.')->group(function () {
    Route::post('/pipedrive/create-opportunity',    [SyncController::class, 'syncCreatedOpportunityFromPipeDrive'])->name('create');
    Route::post('/pipedrive/update-opportunity',    [SyncController::class, 'syncUpdatedOpportunityFromPipeDrive'])->name('update');
    Route::post('/pipedrive/sync-activities',       [SyncController::class, 'syncPipeDriveActivitiesToEvoTalks'])->name('sync-activities');
});

Route::prefix('controle')->name('controle.')->middleware('jwt.auth')->group(function () {
    Route::post('/receive-Opportunity',             [ControleController::class, 'receiveOpportunity'])->name('create');
    Route::post('/update-tag-contole',              [UpdateTag::class, 'updateTag'])->name('updateTag');
    Route::get( '/count-locacao/{idEmpresa}',       [ControleController::class, 'countLocacao'])->name('count');
});

Route::prefix('api4com')->name('api4com')->group(function () {
    Route::post('/api4comCall',                     [Api4Controller::class, 'api4comCall'])->name('api4comCall');
});

Route::prefix('crmevo')->name('crmevo')->group(function () {
    Route::post('/sendWaTemplate',                  [CRMController::class, 'sendWaTemplate'])->name('sendWaTemplate');
    Route::post('/newClientTag',                    [CRMController::class, 'newClientTag'])->name('newClientTag');
    Route::post('/openNewChat',                     [CRMController::class, 'openNewChat'])->name('openNewChat');
});
